package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.DetailDiagnosaTindakanPasien;

import com.jasamedika.medifirst2000.vo.DetailDiagnosaTindakanPasienVO;

@Component
public class DetailDiagnosaTindakanPasienConverter implements BaseVoConverter<DetailDiagnosaTindakanPasienVO, DetailDiagnosaTindakanPasien> {


	@Override
	public DetailDiagnosaTindakanPasien transferVOToModel(DetailDiagnosaTindakanPasienVO vo, DetailDiagnosaTindakanPasien model) {
		if (null == model)
			model = new DetailDiagnosaTindakanPasien();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, DetailDiagnosaTindakanPasien.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<DetailDiagnosaTindakanPasienVO> transferListOfModelToListOfVO(List<DetailDiagnosaTindakanPasien> models, List<DetailDiagnosaTindakanPasienVO> vos) {

		if (null == vos)
			vos = new ArrayList<DetailDiagnosaTindakanPasienVO>();

		if (null == models)
			return vos;

		for (DetailDiagnosaTindakanPasien diagnosaTindakanPasien : models) {
			DetailDiagnosaTindakanPasienVO vo = new DetailDiagnosaTindakanPasienVO();
			vo=transferModelToVO(diagnosaTindakanPasien, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public DetailDiagnosaTindakanPasienVO transferModelToVO(DetailDiagnosaTindakanPasien model, DetailDiagnosaTindakanPasienVO vo) {
		if (null == vo)
			vo = new DetailDiagnosaTindakanPasienVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, DetailDiagnosaTindakanPasienVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	public DetailDiagnosaTindakanPasienVO transferModelToVOCustom(DetailDiagnosaTindakanPasien model, DetailDiagnosaTindakanPasienVO vo,String[] fieldsToInclude) {
		if (null == vo)

		vo = new DetailDiagnosaTindakanPasienVO();

		try {
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, DetailDiagnosaTindakanPasienVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
	
	
	

}
